--By Worba of Petopia 7/31/11

local frame = CreateFrame("FRAME", "Worb_RPet_Frame");
frame:RegisterEvent("ADDON_LOADED");
local function eventHandler(self, event, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10, arg11, arg12, arg13)

	if event == "ADDON_LOADED" then
		if arg1 == "Worb_RPet" then
			print(arg1.." [AddOn active]")
		end

	end

end
frame:SetScript("OnEvent", eventHandler);

local petFamily, petSelected

Pet_Types = {};

table.insert(Pet_Types, { Type = "Bat", Family = "Cunning"});
table.insert(Pet_Types, { Type = "Bird of Prey", Family = "Cunning"});
table.insert(Pet_Types, { Type = "Chimaera", Family = "Cunning"});
table.insert(Pet_Types, { Type = "Dragonhawk", Family = "Cunning"});
table.insert(Pet_Types, { Type = "Monkey", Family = "Cunning"});
table.insert(Pet_Types, { Type = "Nether Ray", Family = "Cunning"});
table.insert(Pet_Types, { Type = "Ravager", Family = "Cunning"});
table.insert(Pet_Types, { Type = "Serpent", Family = "Cunning"});
table.insert(Pet_Types, { Type = "Silithid", Family = "Cunning"});
table.insert(Pet_Types, { Type = "Spider", Family = "Cunning"});
table.insert(Pet_Types, { Type = "Sporebat", Family = "Cunning"});
table.insert(Pet_Types, { Type = "Wind Serpent", Family = "Cunning"});

table.insert(Pet_Types, { Type = "Carrion Bird", Family = "Ferocity"});
table.insert(Pet_Types, { Type = "Cat", Family = "Ferocity"});
table.insert(Pet_Types, { Type = "Core Hound", Family = "Ferocity"});
table.insert(Pet_Types, { Type = "Devilsaur", Family = "Ferocity"});
table.insert(Pet_Types, { Type = "Dog", Family = "Ferocity"});
table.insert(Pet_Types, { Type = "Fox", Family = "Ferocity"});
table.insert(Pet_Types, { Type = "Hyena", Family = "Ferocity"});
table.insert(Pet_Types, { Type = "Moth", Family = "Ferocity"});
table.insert(Pet_Types, { Type = "Raptor", Family = "Ferocity"});
table.insert(Pet_Types, { Type = "Spirit Beast", Family = "Ferocity"});
table.insert(Pet_Types, { Type = "Tallstrider", Family = "Ferocity"});
table.insert(Pet_Types, { Type = "Wasp", Family = "Ferocity"});
table.insert(Pet_Types, { Type = "Wolf", Family = "Ferocity"});

table.insert(Pet_Types, { Type = "Bear", Family = "Tenacity"});
table.insert(Pet_Types, { Type = "Beetle", Family = "Tenacity"});
table.insert(Pet_Types, { Type = "Boar", Family = "Tenacity"});
table.insert(Pet_Types, { Type = "Crab", Family = "Tenacity"});
table.insert(Pet_Types, { Type = "Crocolisk", Family = "Tenacity"});
table.insert(Pet_Types, { Type = "Gorilla", Family = "Tenacity"});
table.insert(Pet_Types, { Type = "Rhino", Family = "Tenacity"});
table.insert(Pet_Types, { Type = "Scorpid", Family = "Tenacity"});
table.insert(Pet_Types, { Type = "Shale Spider", Family = "Tenacity"});
table.insert(Pet_Types, { Type = "Turtles", Family = "Tenacity"});
table.insert(Pet_Types, { Type = "Warp Stalker", Family = "Tenacity"});
table.insert(Pet_Types, { Type = "Worm", Family = "Tenacity"});

Pet_Matches = {}

SLASH_WORB_RPET1 = "/worb_rpet"
SlashCmdList["WORB_RPET"] = function(msg)

	-- Place a random pet on the cursor

	for i = 6, 25 do
		petIcon, petName, petLevel, petType, petLoyalty = GetStablePetInfo(i)
		if petType ~= nil then
			WoRP_GetFamily(petType)
			if msg == "Any" or msg == petFamily then		
				table.insert(Pet_Matches, { MatchName = petName, MatchID = i })
			end
		end
	end

	if #Pet_Matches > 0 then
		-- 1+ matches found, load to cursor
		petSelected = random(#Pet_Matches)
		RaidNotice_AddMessage(RaidBossEmoteFrame, "Summoning "..Pet_Matches[petSelected].MatchName, ChatTypeInfo['RAID_WARNING'])
		PickupStablePet(Pet_Matches[petSelected].MatchID)
		table.wipe(Pet_Matches)
		petSelected = nil
	end

end


WoRP_GetFamily = function(msg)

	-- Return family of the pet

	petFamily = nil

	foreach(Pet_Types, 
		function(k,v)
			if msg == v.Type then
				-- Type found, return family (must write to variable not return as the latter returns nil in this context)
				petFamily = v.Family
				return;
			end
		end
	);

end